## mingw-w64-abinit-10.0.9-1.src.tar.zst

=== requirements.txt ===
html2text

# Pinned versions for website deployment
mkdocs==1.1.2
mkdocs-material==7.0.6
jinja2<3.1.0

pymdown-extensions==8.2
python-markdown-math
pyyaml
pygments
pybtex

#graphviz or python-graphviz if conda
#py_w3c

# Unit tests
pytest
#pytest-cov

abimkdocs_plugin/.

=== shared/CMakeLists.txt ===
add_subdirectory(common)
#add_subdirectory(libpaw)

=== src/43_ptgroups/CMakeLists.txt ===
#
# 43_ptgroups
#
add_library(43_ptgroups STATIC
  m_defs_ptgroups.F90
  m_ptgroups.F90
  m_ptg_C1.F90
  m_ptg_Ci.F90
  m_ptg_C2.F90
  m_ptg_Cs.F90
  m_ptg_C2h.F90
  m_ptg_D2.F90
  m_ptg_C2v.F90
  m_ptg_D2h.F90
  m_ptg_C4.F90
  m_ptg_S4.F90
  m_ptg_C4h.F90
  m_ptg_D4.F90
  m_ptg_C4v.F90
  m_ptg_D2d.F90
  m_ptg_D4h.F90
  m_ptg_C3.F90
  m_ptg_C3i.F90
  m_ptg_D3.F90
  m_ptg_C3v.F90
  m_ptg_D3d.F90
  m_ptg_C6.F90
  m_ptg_C3h.F90
  m_ptg_C6h.F90
  m_ptg_D6.F90
  m_ptg_C6v.F90
  m_ptg_D3h.F90
  m_ptg_D6h.F90
  m_ptg_T.F90
  m_ptg_Th.F90
  m_ptg_O.F90
  m_ptg_Td.F90
  m_ptg_Oh.F90
  )

set_target_properties(43_ptgroups
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(43_ptgroups
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(43_ptgroups
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(43_ptgroups
  PUBLIC
  28_numeric_noabirule
  32_util)

add_library(abinit::43_ptgroups ALIAS 43_ptgroups)

=== src/43_wvl_wrappers/CMakeLists.txt ===
#
# 43_wvl_wrappers
#
add_library(43_wvl_wrappers STATIC
  defs_wvltypes.F90
  defs_PSolver.F90
  m_abi2big.F90
  m_paw2wvl.F90
  m_wvl_denspot.F90
  m_wvl_descr_psp.F90
  m_wvl_projectors.F90
  m_wvl_wfs.F90
  )

set_target_properties(43_wvl_wrappers
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(43_wvl_wrappers
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(43_wvl_wrappers
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(43_wvl_wrappers
  PUBLIC
  abinit::41_geometry)

if(ABINIT_BIGDFT_FOUND)
  target_link_libraries(43_wvl_wrappers
    PUBLIC
    abinit::bigdft)
endif()

add_library(abinit::43_wvl_wrappers ALIAS 43_wvl_wrappers)

=== src/44_abitools/CMakeLists.txt ===
#
# 44_abitools
#
add_library(44_abitools STATIC
  m_berrytk.F90
  m_cgtools.F90
  m_dynmat.F90
  m_integrals.F90
  m_macroave.F90
  m_nvtx_data.F90
  m_wfutils.F90
  )

set_target_properties(44_abitools
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(44_abitools
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(44_abitools
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(44_abitools
  PUBLIC
  28_numeric_noabirule
  32_util
  39_libpaw
  41_geometry)

if(ABINIT_ENABLE_GPU_CUDA OR ABINIT_ENABLE_GPU_HIP)
  target_link_libraries(44_abitools
    PUBLIC
    abinit::17_gpu_toolbox
    )
endif()

if(OpenMP_FOUND)
  target_link_libraries(44_abitools
    PUBLIC
    OpenMP::OpenMP_Fortran)
endif()

add_library(abinit::44_abitools ALIAS 44_abitools)

=== src/45_geomoptim/CMakeLists.txt ===
#
# 45_geomoptim
#
add_library(45_geomoptim STATIC
  m_predtk.F90
  m_abihist.F90
  m_abimover.F90
  m_abiimages.F90
  m_bfgs.F90
  m_ga.F90
  m_hmc.F90
  m_ipi.F90
  m_lbfgs.F90
  m_mep.F90
  m_m1geo.F90
  m_pimd.F90
  m_use_ga.F90
  m_pimd_langevin.F90
  m_pimd_nosehoover.F90
  m_pred_bfgs.F90
  m_pred_delocint.F90
  m_pred_diisrelax.F90
  m_pred_fire.F90
  m_pred_hmc.F90
  m_pred_isokinetic.F90
  m_pred_isothermal.F90
  m_pred_langevin.F90
  m_pred_moldyn.F90
  m_pred_nose.F90
  m_pred_simple.F90
  m_pred_srkna14.F90
  m_pred_steepdesc.F90
  m_pred_velverlet.F90
  m_pred_verlet.F90
  m_predict_neb.F90
  m_predict_pimd.F90
  m_predict_steepest.F90
  m_predict_string.F90
  m_xfpack.F90
  )

set_target_properties(45_geomoptim
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(45_geomoptim
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(45_geomoptim
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(45_geomoptim
  PUBLIC
  abinit::44_abitypes_defs)

add_library(abinit::45_geomoptim ALIAS 45_geomoptim)

=== src/46_ghc_omp/CMakeLists.txt ===
#
# 46_ghc_omp
#
set(46_ghc_omp_SRC
  m_ompgpu_utils.F90
  m_ompgpu_fourwf.F90
  )

add_library(46_ghc_omp STATIC
  ${46_ghc_omp_SRC})

set_target_properties(46_ghc_omp
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(46_ghc_omp
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  ${CMAKE_SOURCE_DIR}/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(46_ghc_omp
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(46_ghc_omp
  PUBLIC
  abinit::10_defs
  abinit::16_hideleave
  abinit::28_numeric_noabirule
  )

if(ABINIT_ENABLE_GPU_CUDA)
  target_link_libraries(46_ghc_omp
    PUBLIC
    abinit::46_manage_cuda
    )
endif()

if(OpenMP_FOUND)
  target_link_libraries(46_ghc_omp
    PUBLIC
    OpenMP::OpenMP_Fortran)
endif()

if(HAVE_OPENMP_OFFLOAD)
  target_compile_options(46_ghc_omp
    PRIVATE
    $<$<COMPILE_LANGUAGE:Fortran>:${OPENMP_OFFLOAD_FLAGS}>)
endif()

add_library(abinit::46_ghc_omp ALIAS 46_ghc_omp)

=== src/46_manage_cuda/CMakeLists.txt ===
#
# 46_manage_cuda
#
add_library(46_manage_cuda STATIC
  m_manage_cuda.F90
  abi_gpu_header.h
  cuda_rec.cu
  cuda_rec_cut.cu
  density.cu
  gpu_apply_invovl_inner.cu
  gpu_apply_local_potential.cu
  gpu_compute_nl_hamiltonian.cu
  gpu_compute_nl_projections.cu
  gpu_density_accumulation.cu
  gpu_fourwf.cu
  gpu_fourwf_managed.cu
  gpu_gemm_nonlop.cu
  gpu_gemm_nonlop.h
  gpu_mkkpg.cu
  gpu_nonlop.cu
  gpu_sphere.cu
  gpu_fftbox.cu
  prt_utils_rec.cu
  rec_dens_calc.cu
  rec_kernels.cu
  recursion_bth.cu
  recursion_cut_bth.cu
  recursion_cut_no_bth.cu
  recursion_no_bth.cu
  )

set_target_properties(46_manage_cuda
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(46_manage_cuda
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  ${CMAKE_CURRENT_SOURCE_DIR}
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  ${CMAKE_SOURCE_DIR}/src/incs
  )

target_compile_definitions(46_manage_cuda
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(46_manage_cuda
  PUBLIC
  abinit::17_gpu_toolbox
  abinit::44_abitypes_defs
  )

if(ABINIT_ENABLE_GPU_CUDA)
  target_link_libraries(46_manage_cuda
    PUBLIC
    CUDA::cufft
    CUDA::cublas
    )
endif()

add_library(abinit::46_manage_cuda ALIAS 46_manage_cuda)

=== src/49_gw_toolbox_oop/CMakeLists.txt ===
#
# 49_gw_toolbox_oop
#
add_library(49_gw_toolbox_oop STATIC
  m_bs_defs.F90
  m_gwdefs.F90
  m_melemts.F90
  m_spectra.F90
  )

set_target_properties(49_gw_toolbox_oop
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(49_gw_toolbox_oop
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(49_gw_toolbox_oop
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(49_gw_toolbox_oop
  PUBLIC
  abinit::44_abitypes_defs)

add_library(abinit::49_gw_toolbox_oop ALIAS 49_gw_toolbox_oop)

=== src/51_manage_mpi/CMakeLists.txt ===
#
# 51_manage_mpi
#
add_library(51_manage_mpi STATIC
  m_io_redirect.F90
  m_mpinfo.F90
  m_wffile.F90
  m_xredistribute.F90
  )

set_target_properties(51_manage_mpi
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(51_manage_mpi
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(51_manage_mpi
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(51_manage_mpi
  PUBLIC
  abinit::44_abitypes_defs)

add_library(abinit::51_manage_mpi ALIAS 51_manage_mpi)

=== src/53_ffts/CMakeLists.txt ===
#
# 53_ffts
#
add_library(53_ffts STATIC
  m_fft.F90
  )

set_target_properties(53_ffts
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(53_ffts
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(53_ffts
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(53_ffts
  PUBLIC
  abinit::46_ghc_omp
  abinit::52_fft_mpi_noabirule
  )

if(ABINIT_ENABLE_GPU_CUDA)
  target_link_libraries(53_ffts
    PUBLIC
    abinit::46_manage_cuda
    )
endif()

if(OpenMP_FOUND)
  target_link_libraries(53_ffts
    PUBLIC
    OpenMP::OpenMP_Fortran)
endif()

add_library(abinit::53_ffts ALIAS 53_ffts)

=== src/54_spacepar/CMakeLists.txt ===
#
# 54_spacepar
#
add_library(54_spacepar STATIC
  m_multipoles.F90
  m_spacepar.F90
  )

set_target_properties(54_spacepar
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(54_spacepar
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(54_spacepar
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(54_spacepar
  PUBLIC
  abinit::53_ffts
  )

if(OpenMP_FOUND)
  target_link_libraries(54_spacepar
    PUBLIC
    OpenMP::OpenMP_Fortran)
endif()

add_library(abinit::54_spacepar ALIAS 54_spacepar)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=abinit
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=10.0.9
pkgrel=1
pkgdesc="Atomic-scale simulation software. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='https://www.abinit.org'
msys2_repository_url="https://github.com/abinit/abinit"
msys2_references=(
  'aur: abinit'
)
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-cc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-libpsml"
         "${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-netcdf-fortran"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-omp")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-msmpi"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-wannier90")
source=("https://forge.abinit.org/${_realname}-${pkgver}.tar.gz"
        "001-fix-build-on-mingw.patch"
        "002-fix-pkgconfig-file.patch"
        "003-fix-version.patch")
sha256sums=('17650580295e07895f6c3c4b1f3f0fe0e0f3fea9bab5fd8ce7035b16a62f8e5e'
            '41ee6253fffc56503ebf2a11ddc5016f67fb014717588b28eedd9381af96399d'
            '466f7f86384f02c99e9f7a948f2b38229a10962ff849cd1e8bf06b0c6ddd7481'
            '72f10de92d58e54ffc814ff03956ca1db89e92c893b9896b774a29f0abff516f')

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  patch -Np1 -i "${srcdir}"/001-fix-build-on-mingw.patch
  patch -Np1 -i "${srcdir}"/002-fix-pkgconfig-file.patch
  patch -Np1 -i "${srcdir}"/003-fix-version.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  FFLAGS="-O2" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=;-DPYMOD_INSTALL_LIBDIR=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_C_STANDARD=17 \
      "${_extra_config[@]}" \
      -DBLA_VENDOR=OpenBLAS \
      -DWANNIER_ROOT=${MINGW_PREFIX} \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/COPYING \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/COPYING
}
